
	move.l	a0,a2
	move.l	d0,d2
	bsr	OpenLibraries
	bsr	AllocMemory
	bsr	MakeIOStdReq
	bsr	MakeReplyPort
	move.l	a2,a0
	move.l	d2,d0
	move.l	DirName,a1
	bsr	ReadDirName
	move.l	DirName,d1
	bsr	LockFile
	move.l	d0,ThisLock
	beq	FastList1
	move.l	ThisLock,a0
	bsr	FindDriveUnit
	move.l	d0,UnitNr
	bsr	OpenTrackDisk
	move.l	ThisLock,d1
	bsr	ShowDirectory
	move.l	ThisLock,d1
	bsr	UnLockFile
FastList1:
	bsr	CloseTrackDisk
	bsr	FreeMemory
	bsr	CloseLibraries
	moveq	#$00,d0
	rts

ReadDirName:		;A0=Commandline,D0=NrChars,A1=DirName
	movem.l	d1/d2/a1,-(a7)
	moveq	#$20,d2
ReadDirName1:
	subq.l	#1,d0
	bmi	ReadDirName3
	move.b	(a0)+,d1
	beq	ReadDirName3
	cmp.b	#$20,d1
	beq	ReadDirName1
	cmp.b	#$0a,d1
	beq	ReadDirName3
	cmp.b	#$22,d1
	bne	ReadDirName2
	move.b	d1,d2
	subq.l	#1,d0
	bmi	ReadDirName3
	move.b	(a0)+,d1
ReadDirName2:
	move.b	d1,(a1)+
	subq.l	#1,d0
	bmi	ReadDirName3
	move.b	(a0)+,d1
	cmp.b	#$0a,d1
	beq	ReadDirName3
	cmp.b	d2,d1
	bne	ReadDirName2
ReadDirName3:
	clr.b	(a1)
	movem.l	(a7)+,d1/d2/a1
	rts

LockFile:		;D1=DirName
	movem.l	d1/d2/a6,-(a7)
	move.l	DosBase,a6
	moveq	#-2,d2
	jsr	-84(a6)		;Lock(name,type)(D1/D2)
	movem.l	(a7)+,d1/d2/a6
	rts

UnLockFile:		;D1=Lock
	movem.l	d1/a6,-(a7)
	move.l	DosBase,a6
	jsr	-90(a6)		;UnLock(lock)(D1)
	movem.l	(a7)+,d1/a6
	rts

OpenLibraries:
	movem.l	a1/a6,-(a7)
	move.l	$0004.w,a6
	lea	DOS_Name(pc),a1
	jsr	-408(a6)		;OldOpenLibrary(libName)(A1)
	move.l	d0,DosBase
	lea	INTUITION_Name(pc),a1
	jsr	-408(a6)		;OldOpenLibrary(libName)(A1)
	move.l	d0,IntuitionBase
	move.l	DosBase,a6
	jsr	-60(a6)			;Output()
	move.l	d0,Output
	movem.l	(a7)+,a1/a6
	rts

CloseLibraries:
	movem.l	a1/a6,-(a7)
	move.l	$0004.w,a6
	move.l	DosBase,a1
	jsr	-414(a6)		;CloseLibrary(library)(A1)
	move.l	IntuitionBase,a1
	jsr	-414(a6)		;CloseLibrary(library)(A1)
	movem.l	(a7)+,a1/a6
	rts

AllocMemory:
	movem.l	d1/a6,-(a7)
	move.l	$0004.w,a6
	move.l	#$00000050,d0
	move.l	#$00010000,d1		;Clear
	jsr	-198(a6)		;AllocMem(D0,D1)
	move.l	d0,DirName
	move.l	#$00000050,d0
	move.l	#$00010000,d1		;Clear
	jsr	-198(a6)		;AllocMem(D0,D1)
	move.l	d0,TextBuff
	move.l	#$00000030,d0
	move.l	#$00010000,d1		;Clear
	jsr	-198(a6)		;AllocMem(D0,D1)
	move.l	d0,IOStdReq
	move.l	#$00000022,d0
	move.l	#$00010000,d1		;Clear
	jsr	-198(a6)		;AllocMem(D0,D1)
	move.l	d0,ReplyPort
	move.l	#$00000104,d0
	move.l	#$00010000,d1		;Clear
	jsr	-198(a6)		;AllocMem(D0,D1)
	move.l	d0,FileInfoBlock
	move.l	#$00000240,d0
	move.l	#$00010000,d1		;Clear
	jsr	-198(a6)		;AllocMem(D0,D1)
	move.l	d0,WorkBuff
	move.l	#$00000200,d0
	move.l	#$00010002,d1		;Chip|Clear
	jsr	-198(a6)		;AllocMem(D0,D1)
	move.l	d0,DiskBuff
	movem.l	(a7)+,d1/a6
	rts

FreeMemory:
	movem.l	a1/a6,-(a7)
	move.l	$0004.w,a6
	move.l	DirName,a1
	move.l	#$00000050,d0
	jsr	-210(a6)		;FreeMem(A1,D0)
	move.l	TextBuff,a1
	move.l	#$00000050,d0
	jsr	-210(a6)		;FreeMem(A1,D0)
	move.l	IOStdReq,a1
	move.l	#$00000030,d0
	jsr	-210(a6)		;FreeMem(A1,D0)
	move.l	ReplyPort,a1
	move.l	#$00000022,d0
	jsr	-210(a6)		;FreeMem(A1,D0)
	move.l	FileInfoBlock,a1
	move.l	#$00000104,d0
	jsr	-210(a6)		;FreeMem(A1,D0)
	move.l	WorkBuff,a1
	move.l	#$00000240,d0
	jsr	-210(a6)		;FreeMem(A1,D0)
	move.l	DiskBuff,a1
	move.l	#$00000200,d0
	jsr	-210(a6)		;FreeMem(A1,D0)
	movem.l	(a7)+,a1/a6
	rts

MakeIOStdReq:
	movem.l	a1-a2,-(a7)
	move.l	IOStdReq,a2
	move.b	#$05,$0008(a2)		;ln_Type
	lea	Node_Name(pc),a1
	move.l	a1,$000a(a2)		;ln_Name
	move.l	ReplyPort,$000e(a2)	;mn_ReplyPort
	movem.l	(a7)+,a1-a2
	rts
*************************************************************************
* IOStdReq:
* $0030 sizeof(IOStdReq)
* $0000 io_Message
* $0014 io_Device
* $0018 io_Unit
* $001c io_Command
* $001e io_Flags
* $001f io_Error
* $0020 io_Actual
* $0024 io_Length
* $0028 io_Data
* $002c io_Offset
*************************************************************************
* Message:
* $0014 sizeof(Message)
* $0000 mn_Node
* $000e mn_ReplyPort
* $0012 mn_Length
*************************************************************************
* Node:
* $000e sizeof(Node)
* $0000 ln_Succ
* $0004 ln_Pred
* $0008 ln_Type
* $0009 ln_Pri
* $000a ln_Name
*************************************************************************

MakeReplyPort:
	movem.l	a1-a2/a6,-(a7)
	move.l	ReplyPort,a2
	move.b	#$04,$0008(a2)		;ln_Type
	lea	Node_Name(pc),a1
	move.l	a1,$000a(a2)		;ln_Name
	move.l	$0004.w,a6
	suba.l	a1,a1
	jsr	-294(a6)		;FindTask(name)(A1)
	move.l	d0,$0010(a2)		;mp_SigTask
	moveq	#$ffffffff,d0
	jsr	-330(a6)		;AllocSignal(signalNum)(D0)
	move.b	d0,$000f(a2)		;mp_SigBit
	movem.l	(a7)+,a1-a2/a6
	rts
*************************************************************************
* MsgPort:
* $0022 sizeof(MsgPort)
* $0000 mp_Node
* $000e mp_Flags
* $000f mp_SigBit
* $0010 mp_SigTask
* $0014 mp_MsgList
*************************************************************************
* List:
* $000e sizeof(List)
* $0000 lh_Head
* $0004 lh_Tail
* $0008 lh_TailPred
* $000c lh_Type
* $000d lh_pad
*************************************************************************

OpenTrackDisk:
	movem.l	d1/a1/a6,-(a7)
	move.l	$0004.w,a6
	lea	TD_Name(pc),a0		;devName
	move.l	UnitNr,d0		;unit
	bmi	OpenTrackDisk1
	move.l	IOStdReq,a1		;ioRequest
	moveq	#$01,d1			;flags
	jsr	-444(a6)		;OpenDevice(A0,D0,A1,D1)
OpenTrackDisk1:
	movem.l	(a7)+,d1/a1/a6
	rts

CloseTrackDisk:
	movem.l	a1/a6,-(a7)
	move.l	$0004.w,a6
	move.l	UnitNr,d0
	bmi	CloseTrackDisk1
	move.l	IOStdReq,a1		;ioRequest
	move.w	#$0009,$001c(a1)	;io_Command
	clr.l	$0024(a1)		;io_Length
	jsr	-456(a6)		;DoIO(ioRequest)(A1)
	move.l	IOStdReq,a1		;ioRequest
	jsr	-450(a6)		;CloseDevice(A1)
CloseTrackDisk1:
	move.l	ReplyPort,a1		;MsgPort
	moveq	#$00,d0
	move.b	15(a1),d0		;mp_SigBit
	jsr	-336(a6)		;FreeSignal(D0)
	movem.l	(a7)+,a1/a6
	rts

FindDriveUnit:			;A0=Lock
	movem.l	d1/a0/a1,-(a7)
	add.l	a0,a0
	add.l	a0,a0
	move.l	$0c(a0),d1		;fl_Task
	move.l	DosBase,a1		;DosBase
	move.l	$22(a1),a1		;RootNode
	move.l	$18(a1),a1		;DosInfo
	add.l	a1,a1
	add.l	a1,a1
	move.l	$4(a1),a1		;DevInfo
	add.l	a1,a1
	add.l	a1,a1
FindDriveUnit1:
	tst.l	$4(a1)			;dvi_Type
	bne	FindDriveUnit3
	cmp.l	$8(a1),d1		;dvi_Task
	bne	FindDriveUnit3
	tst.l	$1c(a1)			;dvi_Startup
	beq	FindDriveUnit3
	move.l	$1c(a1),a0		;dvi_Startup
	add.l	a0,a0
	add.l	a0,a0
	move.l	(a0)+,d0		;fssm_Unit
	and.l	#$00000003,d0
	move.l	(a0),a0			;fssm_Device
	add.l	a0,a0
	add.l	a0,a0
	cmp.l	#$11747261,(a0)
	bne	FindDriveUnit3
FindDriveUnit2:	
	movem.l	(a7)+,d1/a0/a1
	rts
FindDriveUnit3:
	moveq	#$ffffffff,d0
	tst.l	(a1)			;dvi_Next
	beq	FindDriveUnit2
	move.l	(a1),a1			;dvi_Next
	add.l	a1,a1
	add.l	a1,a1
	bra	FindDriveUnit1

ReadBlock:			;A0=DiskBlock,D0=Blocknr
	movem.l	a1/a6,-(a7)
	move.l	$4,a6			;ExecBase
	move.l	IOStdReq,a1		;ioRequest
	move.w	#$0002,$001c(a1)	;io_Command
	move.b	#$01,$001e(a1)		;io_Flags
	move.l	#$00000200,$0024(a1)	;io_Length
	move.l	a0,$0028(a1)		;io_Data
	mulu	#$0200,d0
	move.l	d0,$002c(a1)		;io_Offset
	jsr	-456(a6)		;DoIO(ioRequest)(A1)
	movem.l	(a7)+,a1/a6
	rts

MakeFileInfoBlock:		;A0=DiskBlock,A1=FileInfoBlock
	movem.l	d0/a2/a3,-(a7)
	move.l	$4(a0),(a1)		;fib_DiskKey
	move.l	$1fc(a0),4(a1)		;fib_DirEntryType
	moveq	#$00,d0
MakeFileInfoBlock1:
	clr.l	8(a1,d0.w)
	addq.w	#4,d0
	cmp.w	#$00fc,d0
	bne	MakeFileInfoBlock1
	lea	$1b0(a0),a2
	lea	$8(a1),a3		;fib_FileName[0]
	moveq	#$00,d0
	move.b	(a2)+,d0
MakeFileInfoBlock2:
	move.b	(a2)+,(a3)+
	dbf	d0,MakeFileInfoBlock2
	clr.b	$ffffffff(a3)
	move.l	$140(a0),$74(a1)	;fib_Protection
	move.l	$1fc(a0),$78(a1)	;fib_EntryType
	move.l	$144(a0),$7c(a1)	;fib_Size
	move.l	$8(a0),$80(a1)		;fib_NumBlocks
	move.l	$1a4(a0),$84(a1)	;fib_Date
	move.l	$1a8(a0),$88(a1)
	move.l	$1ac(a0),$8c(a1)
	lea	$148(a0),a2
	lea	$90(a1),a3		;fib_Comment[0]
	moveq	#$00,d0
	move.b	(a2)+,d0
MakeFileInfoBlock3:
	move.b	(a2)+,(a3)+
	dbf	d0,MakeFileInfoBlock3
	clr.b	$ffffffff(a3)
	movem.l	(a7)+,d0/a2/a3
	rts

GetNextEntry:			;A0=DiskBlock,A1=EntryList
	movem.l	d1-d3/a1-a2,-(a7)
	moveq	#-1,d1
	moveq	#-1,d2
	moveq	#72-1,d3
GetNextEntry1:
	tst.l	(a1)
	beq	GetNextEntry3
	cmp.l	$120(a1),d2
	bhi	GetNextEntry2
	bne	GetNextEntry3
	cmp.l	(a1),d1
	bls	GetNextEntry3
GetNextEntry2:
	move.l	$120(a1),d2
	move.l	(a1),d1
	move.l	a1,a2
GetNextEntry3:
	addq.l	#4,a1
	dbf	d3,GetNextEntry1
	moveq	#$00,d0
	tst.l	d1
	bmi	GetNextEntry5		;LastEntry
	move.l	d1,d0
	move.l	a0,a1
	bsr	ReadBlock
	move.l	$1f0(a1),d0		;NextEntry
	move.l	d0,(a2)
	beq.s	GetNextEntry4
	cmp.l	d1,d0
	bhi	GetNextEntry4
	divu	#11,d0
	divu	#11,d1
	cmp.w	d0,d1
	beq	GetNextEntry4		;On Same Track
	addq.l	#1,$120(a2)		;Next Cycle
GetNextEntry4:
	moveq	#$ffffffff,d0
GetNextEntry5:
	movem.l	(a7)+,d1-d3/a1-a2
	rts

LoadEntryList:		;A0=Lock,A1=EntryList
	move.l	a1,-(a7)
	add.l	a0,a0
	add.l	a0,a0
	move.l	$4(a0),d0		;fl_Key
	move.l	Diskbuff,a0
	bsr	ReadBlock
	move.l	Diskbuff,a0
	moveq	#72-1,d0
	tst.l	$1fc(a0)
	bmi	LoadEntryList2		;File
	lea	$18(a0),a0
LoadEntryList1:
	move.l	(a0)+,(a1)+
	dbf	d0,LoadEntryList1
	moveq	#72-1,d0
LoadEntryList2:
	clr.l	(a1)+
	dbf	d0,LoadEntryList2
	move.l	(a7)+,a1
	rts

NewExamine:		;D1=Lock,D2=FileInfoBlock
	movem.l	d1-d7/a1-a6,-(a7)
	tst.l	UnitNr
	bmi	NewExamine1
	move.l	d1,a0
	move.l	WorkBuff,a1
	bsr	LoadEntryList
	move.l	DiskBuff,a0
	move.l	d2,a1
	bsr	MakeFileInfoBlock
	moveq	#$ffffffff,d0
	move.l	d0,d1
	movem.l	(a7)+,d1-d7/a1-a6
	rts
NewExamine1:
	move.l	DosBase,a6
	jsr	-102(a6)		;Examine(D1/D2)
	movem.l	(a7)+,d1-d7/a1-a6
	rts

NewExNext:		;D1=Lock,D2=FileInfoBlock
	movem.l	d1-d7/a1-a6,-(a7)
	tst.l	UnitNr
	bmi	NewExNext2
	move.l	DiskBuff,a0
	move.l	WorkBuff,a1
	bsr	GetNextEntry
	tst.l	d0
	beq	NewExNext1
	move.l	DiskBuff,a0
	move.l	d2,a1
	bsr	MakeFileInfoBlock	
	moveq	#$ffffffff,d0
NewExNext1:
	move.l	d0,d1
	movem.l	(a7)+,d1-d7/a1-a6
	rts
NewExNext2:
	move.l	DosBase,a6
	jsr	-108(a6)		;ExNext(D1/D2)
	movem.l	(a7)+,d1-d7/a1-a6
	rts

WriteChar:
	movem.l	d1-d3/a0-a1,-(a7)
	move.l	Textbuff,a0
	move.w	CursorX,d3
	move.b	d0,0(a0,d3.w)
	addq.w	#1,CursorX
	cmp.b	#$0a,d0
	bne	WriteChar2
	clr.w	CursorX
	move.l	DosBase,a6
	move.l	Output,d1
	move.l	a0,d2
	addq.w	#1,d3
	jsr	-48(a6)
	move.l	Textbuff,a0
	moveq	#$20,d0
	moveq	#$4f,d1
WriteChar1:
	move.b	d0,(a0)+
	dbf	d1,WriteChar1
WriteChar2:
	movem.l	(a7)+,d1-d3/a0-a1
	rts

WriteString:
	move.l	a1,-(a7)
	move.l	d0,a1
WriteString1:
	move.b	(a1)+,d0
	beq	WriteStringEnd
	bsr	WriteChar
	bra	WriteString1
WriteStringEnd:
	move.l	(a7)+,a1
	rts

WriteNumber:
	and.b	#$0f,d0
	cmp.b	#$0a,d0
	bcs	WriteNumber1
	addq.b	#7,d0
WriteNumber1:
	add.b	#$30,d0
	bsr	WriteChar
	rts

WriteDecNumber:			;d0=number,d1=highestten(1000,100...)
	movem.l	d1-d5,-(a7)
	moveq	#$20,d5		;Spaces before number
WriteDecNumberII0:
	move.l	d1,d3
	moveq	#$00,d4
WriteDecNumber0:
	moveq	#-1,d2
	add.l	d3,d0
WriteDecNumber1:
	sub.l	d3,d0
	addq.b	#1,d2
	cmp.l	d3,d0
	beq	WriteDecNumber1
	bhi	WriteDecNumber1
	move.l	d0,d1
	move.b	d2,d0
	tst.b	d4
	bne	WriteDecNumber2
	tst.b	d2
	beq	WriteDecNumber3
WriteDecNumber2:
	moveq	#$01,d4
	bsr	WriteNumber
	bra	WriteDecNumber4
WriteDecNumber3:
	move.b	d5,d0
	beq	WriteDecNumber4
	bsr	WriteChar
WriteDecNumber4:
	move.l	d1,d0
	move.l	d3,d1
	clr.w	d3
	swap	d3
	divu	#$000a,d3
	swap	d3
	swap	d1
	move.w	d3,d1
	swap	d1
	divu	#$000a,d1
	move.w	d1,d3
	cmp.l	#$00000001,d1
	bne	WriteDecNumber0
	bsr	WriteNumber
	movem.l	(a7)+,d1-d5
	rts

WriteDecNumberII:		;d0=number,d1=highestten(1000,100...)
	movem.l	d1-d5,-(a7)
	moveq	#$00,d5			;No Spaces
	bra	WriteDecNumberII0

ConvertDate:		;d0=Days since 01-01-1978
			;d0out=Day,d1out=Month,d2out=Year
	movem.l	d3/d4/a0,-(a7)
	and.l	#$000fffff,d0
	moveq	#$00,d3
	move.l	#1978,d2	;Year
	lea	Datecodes1(pc),a0
ConvertDate1:
	moveq	#$01,d1
ConvertDate2:
	move.b	-1(a0,d1.w),d3
	cmp.b	#28,d3
	bne	ConvertDate3
	move.w	d2,d4
	and.w	#$0003,d4
	bne	ConvertDate3
	addq.w	#1,d3		;29 days in Feb each 4th year
ConvertDate3:
	cmp.l	d0,d3
	bhi	ConvertDate4
	sub.l	d3,d0
	addq.w	#1,d1
	cmp.w	#13,d1
	bne	ConvertDate2
	addq.w	#1,d2
	bra	ConvertDate1
ConvertDate4:
	addq.w	#1,d0
	movem.l	(a7)+,d3/d4/a0
	rts

ConvertTime:		;d0=Min,d1=Seconds*50
			;d0out=Hours,d1out=Min,d2out=Secs
	divu	#50,d1
	move.l	d1,d2
	ext.l	d2
	divu	#60,d0
	move.l	d0,d1
	swap	d1
	ext.l	d1
	ext.l	d0
	rts

WriteTime:		;d0=Hours,d1=Min,d2=Secs
	movem.l	d0-d3,-(a7)
	bsr	WriteTime1
	moveq	#':',d0
	bsr	WriteChar
	move.l	d1,d0
	bsr	WriteTime1
	moveq	#':',d0
	bsr	WriteChar
	move.l	d2,d0
	bsr	WriteTime1
	movem.l	(a7)+,d0-d3
	rts
WriteTime1:
	divu	#10,d0
	move.l	d0,d3
	swap	d3
	bsr	WriteNumber
	move.w	d3,d0
	bsr	WriteNumber
	rts

WriteDate:		;d0=Daynr,d1=Month,d2=Year
	movem.l	d0-d4/a0,-(a7)
	divu	#10,d0
	move.l	d0,d4
	swap	d4
	bsr	WriteNumber
	move.w	d4,d0
	bsr	WriteNumber
	moveq	#'-',d0
	bsr	WriteChar
	lea	Datecodes2(pc),a0
	move.b	-1(a0,d1.w),d1
	ext.w	d1
	add.w	d1,a0
	move.l	a0,d0
	bsr	WriteString
	moveq	#'-',d0
	bsr	WriteChar
	move.l	d2,d0
	divu	#100,d0
	swap	d0
	ext.l	d0
	divu	#10,d0
	move.l	d0,d4
	swap	d4
	bsr	WriteNumber
	move.w	d4,d0
	bsr	WriteNumber
	movem.l	(a7)+,d0-d4/a0
	rts

GetDayOfWeek:		;d0=Daynr,d1=Month,d2=Year
			;d0out=DayOfWeek-Name
	movem.l	d1-d3/a0,-(a7)
	move.w	d2,d3
	and.w	#$0003,d3
	bne	GetDayOfWeek1
	cmp.w	#$0002,d1
	bhi	GetDayOfWeek1
	addq.w	#6,d0
GetDayOfWeek1:
	divu	#100,d2
	lea	Timecodes3(pc),a0
	add.b	0(a0,d2.w),d0		;Century
	swap	d2
	lea	Timecodes4(pc),a0
	add.b	0(a0,d2.w),d0		;Year
	lea	Timecodes2(pc),a0
	add.b	-1(a0,d1.w),d0		;Month
	addq.w	#3,d0
	ext.w	d0
	ext.l	d0
	divu	#$0007,d0
	swap	d0
	lea	Timecodes1(pc),a0
	move.b	0(a0,d0.w),d0
	ext.w	d0
	add.w	d0,a0
	move.l	a0,d0
	movem.l	(a7)+,d1-d3/a0
	rts

ReadSystemDate:
	move.l	a1,-(a7)
	move.l	IntuitionBase,a1
	move.l	$0048(a1),d0		;Seconds
	lsr.l	#1,d0
	divu	#24*60*60/2,d0
	and.l	#$0000ffff,d0
	bsr	ConvertDate
	move.l	(a7)+,a1
	rts

ShowDay:
	movem.l	d1/d2,-(a7)
	bsr	ReadSystemDate
	bsr	GetDayOFWeek
	bsr	WriteString
	movem.l	(a7)+,d1/d2
	rts

ShowDate:
	movem.l	d1/d2,-(a7)
	bsr	ReadSystemDate
	bsr	WriteDate
	movem.l	(a7)+,d1/d2
	rts

WriteProtFlags:		;d0=ProtFlags
	move.l	d1,-(a7)
	move.l	d0,d1
	eor.w	#$00f0,d1
	moveq	#'h',d0
	bsr	WriteProtFlags1
	moveq	#'s',d0
	bsr	WriteProtFlags1
	moveq	#'p',d0
	bsr	WriteProtFlags1
	moveq	#'a',d0
	bsr	WriteProtFlags1
	moveq	#'r',d0
	bsr	WriteProtFlags1
	moveq	#'w',d0
	bsr	WriteProtFlags1
	moveq	#'e',d0
	bsr	WriteProtFlags1
	moveq	#'d',d0
	bsr	WriteProtFlags1
	move.l	(a7)+,d1
	rts
WriteProtFlags1:
	btst	#7,d1
	beq	WriteProtFlags2
	moveq	#'-',d0
WriteProtFlags2:
	bsr	WriteChar
	add.l	d1,d1
	rts

ShowDirectory:		;D1=Lock
	movem.l	d1-d6/a1,-(a7)
	move.l	d1,d6
	clr.l	NrFiles		;Nr of Files
	clr.l	NrDirs		;Nr of Directories
	clr.l	NrBlocks	;Nr of Blocks
	lea	CopyrightText(pc),a0
	move.l	a0,d0
	bsr	WriteString
	move.l	FileInfoBlock,a1
	move.l	d6,d1
	move.l	a1,d2
	bsr	NewExamine
	tst.l	d0
	beq	ShowDirectory6
	tst.l	$0004(a1)
	bmi	ShowDirectory2	;File!
	moveq	#$0a,d0
	bsr	WriteChar
	lea	Directorytext1(pc),a0
	move.l	a0,d0
	bsr	WriteString
	move.l	DirName,a0	;DirectoryName
	move.l	a0,d0
	bsr	WriteString
	lea	Directorytext2(pc),a0
	move.l	a0,d0
	bsr	WriteString
	bsr	ShowDay
	moveq	#$20,d0
	bsr	WriteChar
	bsr	ShowDate
ShowDirectory1:
	move.l	d6,d1
	move.l	a1,d2
	bsr	NewExNext
	tst.l	d0
	beq	ShowDirectory6	;No more files
ShowDirectory2:
	moveq	#$0a,d0
	bsr	WriteChar
	lea	$0008(a1),a0		;fib_FileName[0]
	move.l	a0,d0
	bsr	WriteString
	move.w	#$001a,CursorX
	tst.l	$0004(a1)		;fib_DirEntryType
	bmi	ShowDirectory3		;File
	addq.l	#1,NrDirs		;Nr of Directories
	addq.l	#1,NrBlocks		;Nr of Blocks
	lea	Directorytext3(pc),a0	;Directory
	move.l	a0,d0
	bsr	WriteString
	bra	ShowDirectory4
ShowDirectory3:
	addq.l	#1,NrFiles		;Nr of Files
	move.l	$007c(a1),d0		;fib_Size
	move.l	d0,d1
	add.l	#$000001e7,d1
	divu	#$01e8,d1
	ext.l	d1
	add.l	d1,NrBlocks		;Nr of Blocks
	add.l	#$00000047,d1
	divu	#$0048,d1
	ext.l	d1
	add.l	d1,NrBlocks
	move.l	#100000,d1
	bsr	WriteDecNumber
ShowDirectory4:
	moveq	#$20,d0
	bsr	WriteChar
	move.l	$0074(a1),d0		;fib_Protection
	bsr	WriteProtFlags
	moveq	#$20,d0
	bsr	WriteChar
	move.l	$0084(a1),d0		;fib_Date
	bsr	ConvertDate
	bsr	WriteDate
	moveq	#$20,d0
	bsr	WriteChar
	move.l	$0088(a1),d0		;fib_Date.Time
	move.l	$008c(a1),d1
	bsr	ConvertTime
	bsr	WriteTime
	lea	$0090(a1),a0		;fib_Comment[0]
	tst.b	(a0)
	beq	ShowDirectory5
	moveq	#$0a,d0
	bsr	WriteChar
	moveq	#$3a,d0
	bsr	WriteChar
	moveq	#$20,d0
	bsr	WriteChar
	move.l	a0,d0
	bsr	WriteString
ShowDirectory5:
	bra	ShowDirectory1
ShowDirectory6:
	moveq	#$0a,d0
	bsr	WriteChar
	move.l	#1000000000,d1
	moveq	#$01,d2
	move.l	NrFiles,d0		;Nr of Files
	beq	ShowDirectory8
	bsr	WriteDecNumberII
	lea	Directorytext4(pc),a0
	cmp.l	NrFiles,d2
	bne	ShowDirectory7
	lea	Directorytext4a(pc),a0
ShowDirectory7:
	move.l	a0,d0
	bsr	WriteString
ShowDirectory8:
	move.l	NrDirs,d0		;Nr of Directories
	beq	ShowDirectory10
	bsr	WriteDecNumberII
	lea	Directorytext5(pc),a0
	cmp.l	NrDirs,d2
	bne	ShowDirectory9
	lea	Directorytext5a(pc),a0
ShowDirectory9:
	move.l	a0,d0
	bsr	WriteString
ShowDirectory10:
	move.l	NrBlocks,d0		;Nr of Blocks
	bsr	WriteDecNumberII
	lea	Directorytext6(pc),a0
	cmp.l	NrBlocks,d2
	bne	ShowDirectory11
	lea	Directorytext6a(pc),a0
ShowDirectory11:
	move.l	a0,d0
	bsr	WriteString
	moveq	#$0a,d0
	bsr	WriteChar
	movem.l	(a7)+,d1-d6/a1
	rts

Directorytext1:
	dc.b	"Directory ",$22,0
Directorytext2:
	dc.b	$22," on ",0
Directorytext3:
	dc.b	"   Dir",0
Directorytext4:
	dc.b	" files - ",0
Directorytext4a:
	dc.b	" file - ",0
Directorytext5:
	dc.b	" directories - ",0
Directorytext5a:
	dc.b	" directory - ",0
Directorytext6:
	dc.b	" blocks used",0
Directorytext6a:
	dc.b	" block used",0
CopyrightText:
	dc.b	"FastList V1.0  (C)1990 Per Hkan Sundell",0

Timecodes1:
	dc.b	Tc1-Timecodes1,Tc2-Timecodes1,Tc3-Timecodes1
	dc.b	Tc4-Timecodes1,Tc5-Timecodes1,Tc6-Timecodes1
	dc.b	Tc7-Timecodes1
Tc1:	dc.b	"Monday",0
Tc2:	dc.b	"Tuesday",0
Tc3:	dc.b	"Wednesday",0
Tc4:	dc.b	"Thursday",0
Tc5:	dc.b	"Friday",0
Tc6:	dc.b	"Saturday",0
Tc7:	dc.b	"Sunday",0

Timecodes2:
	dc.b	0,3,3,6,1,4,6,2,5,0,3,5	;Months 1-12 Jan-Dec
Timecodes3:
	dc.b	6,5,4,3,2,1,0		;Century 0-6
	dc.b	6,5,4,3,2,1,0		;7-13
	dc.b	6,5,1,6,4,2,1		;14-20
	dc.b	6,4,2,1,6,4,2		;21-27
	dc.b	1			;28
Timecodes4:
	dc.b	1,2,3,4,6,7		;Year 0-5
	dc.b	1,2,4,5,6,7		;6-11
	dc.b	2,3,4,5,7		;12-16
	dc.b	1,2,3,5,6,7		;17-22
	dc.b	1,3,4,5,6		;23-27
	dc.b	1,2,3,4,6,7		;28-33
	dc.b	1,2,4,5,6,7		;34-39
	dc.b	2,3,4,5,7		;40-44
	dc.b	1,2,3,5,6,7		;45-50
	dc.b	1,3,4,5,6		;51-55
	dc.b	1,2,3,4,6,7		;56-61
	dc.b	1,2,4,5,6,7		;62-67
	dc.b	2,3,4,5,7		;68-72
	dc.b	1,2,3,5,6,7		;73-78
	dc.b	1,3,4,5,6		;79-83
	dc.b	1,2,3,4,6,7		;84-89
	dc.b	1,2,4,5,6,7		;90-95
	dc.b	2,3,4,5			;96-99

Datecodes1:
	dc.b	31,28,31,30,31,30	;Days in month Jan-Dec
	dc.b	31,31,30,31,30,31
	even
Datecodes2:
	dc.b	Dc1-Datecodes2,Dc2-Datecodes2,Dc3-Datecodes2
	dc.b	Dc4-Datecodes2,Dc5-Datecodes2,Dc6-Datecodes2
	dc.b	Dc7-Datecodes2,Dc8-Datecodes2,Dc9-Datecodes2
	dc.b	Dc10-Datecodes2,Dc11-Datecodes2,Dc12-Datecodes2
dc1:	dc.b	"Jan",0
dc2:	dc.b	"Feb",0
dc3:	dc.b	"Mar",0
dc4:	dc.b	"Apr",0
dc5:	dc.b	"May",0
dc6:	dc.b	"Jun",0
dc7:	dc.b	"Jul",0
dc8:	dc.b	"Aug",0
dc9:	dc.b	"Sep",0
dc10:	dc.b	"Oct",0
dc11:	dc.b	"Nov",0
dc12:	dc.b	"Dec",0

Node_Name:
	dc.b	"FastList",0
TD_Name:
	dc.b	"trackdisk.device",0
DOS_Name:
	dc.b	"dos.library",0
INTUITION_Name:
	dc.b	"intuition.library",0
	even

UnitNr:
	dc.l	$ffffffff
CursorX:
	dc.w	0
NrFiles:
	dc.l	0
NrDirs:
	dc.l	0
NrBlocks:
	dc.l	0
DosBase:
	dc.l	0
IntuitionBase:
	dc.l	0
Output:
	dc.l	0
ThisLock:
	dc.l	0
DirName:
	dc.l	0		;$0050 bytes
Textbuff:
	dc.l	0		;$0050 bytes
FileInfoBlock:
	dc.l	0		;$0104 bytes
Workbuff:
	dc.l	0		;$0240 bytes
Diskbuff:
	dc.l	0		;$0200 bytes chipmem
IOStdReq:
	dc.l	0		;$0030 bytes
ReplyPort:
	dc.l	0		;$0022 bytes


