	Section	Program,Code

	incdir	Devpac:Include
	include	exec/exec.i
	include	exec/exec_lib.i
	include	dos/dos.i
	include	dos/dos_lib.i
	include	intuition/intuition.i
	include	intuition/intuition_lib.i
	include	devices/trackdisk.i

	bsr	OpenLibraries
	moveq	#$00,d7
MainLoop
	move.l	d7,d0
	bsr	SetName
	move.l	#FileName,d1
	move.l	#MODE_NEWFILE,d2
	CALLDOS	Open
	move.l	d1,d4
	move.l	d7,d0
	bsr	GetAdress
	move.l	d0,d2
	move.l	d1,d3
	move.l	d4,d1
	CALLDOS	Write
	move.l	d4,d1
	CALLDOS	Close
	addq.w	#1,d7
	cmp.w	#$0d,d7
	bne.s	MainLoop
	bsr	CloseLibraries
	moveq	#$00,d0
	rts


OpenLibraries
	movem.l	a1/a6,-(a7)
	lea	DOS_Name(pc),a1
	CALLEXEC OldOpenLibrary
	move.l	d0,_DOSBase
	lea	INTUITION_Name(pc),a1
	CALLEXEC OldOpenLibrary
	move.l	d0,_IntuitionBase
	CALLDOS	Output
	move.l	d0,Output
	movem.l	(a7)+,a1/a6
	rts

CloseLibraries
	movem.l	a1/a6,-(a7)
	move.l	_DOSBase,a1
	CALLEXEC CloseLibrary
	move.l	_IntuitionBase,a1
	CALLEXEC CloseLibrary
	movem.l	(a7)+,a1/a6
	rts

SetName
	lea	FileName(pc),a1
	move.b	d0,d1
	lsr.b	#4,d0
	bsr	.FixHex
	move.b	d0,1(a1)
	move.b	d1,d0
	and.b	#$0f,d0
	bsr	.FixHex
	move.b	d0,2(a1)
	rts
.FixHex
	add.b	#$30,d0
	cmp.b	#$39,d0
	bls.s	.1
	add.b	#$07,d0
.1
	rts

GetAdress
	move.l	d0,d2
	lsl.l	#4,d2
	lea	$500400,a0
	move.l	0(a0,d2.w),d0
	move.l	4(a0,d2.w),d1
	add.l	#$500000,d0
	tst.b	12(a0,d2.w)
	bne.s	.Extra
	rts
.Extra
	movem.l	a2-a3,-(a7)
	lea	$480000,a2
	move.l	d0,a1
	move.l	d0,a3
	add.l	d1,a3
.Loop
	move.b	(a1)+,(a2)+
	cmpa.l	a1,a3
	bne.s	.Loop
	move.l	8(a0,d2.w),-(a7)
	lea	$480000,a0
	move.l	a0,a1
	jsr	$5915e
	tst.l	d0
	bmi.s	.Fel
	move.l	#$480000,d0
	move.l	(a7)+,d1
	movem.l	(a7)+,a2-a3
	rts
.Fel
	move.w	$dff006,$dff180
	bra.s	.Fel

DOS_Name
	DOSNAME
INTUITION_Name
	INTNAME
FileName
	dc.b	"100",0
	even
_DOSBase
	dc.l	0
_IntuitionBase
	dc.l	0
Output
	dc.l	0



