
	move.l	a0,a2
	move.l	d0,d2
	bsr	OpenLibraries
	bsr	AllocMemory
	bsr	MakeIOStdReq
	bsr	MakeReplyPort
	moveq	#$03,d0
	move.l	d0,UnitNr
	bsr	OpenTrackDisk
	lea	$500000,a0
	move.l	#0,d0
loop	movem.l	a0/d0,-(a7)
	bsr	ReadBlock
	movem.l	(a7)+,d0/a0
	add.l	#$80000,d0
	cmp.l	#$4000000,d0
	bne	loop
	bsr	CloseTrackDisk
	bsr	FreeMemory
	bsr	CloseLibraries
	moveq	#$00,d0
	rts


OpenLibraries:
	movem.l	a1/a6,-(a7)
	move.l	$0004.w,a6
	lea	DOS_Name(pc),a1
	jsr	-408(a6)		;OldOpenLibrary(libName)(A1)
	move.l	d0,DosBase
	lea	INTUITION_Name(pc),a1
	jsr	-408(a6)		;OldOpenLibrary(libName)(A1)
	move.l	d0,IntuitionBase
	move.l	DosBase,a6
	jsr	-60(a6)			;Output()
	move.l	d0,Output
	movem.l	(a7)+,a1/a6
	rts

CloseLibraries:
	movem.l	a1/a6,-(a7)
	move.l	$0004.w,a6
	move.l	DosBase,a1
	jsr	-414(a6)		;CloseLibrary(library)(A1)
	move.l	IntuitionBase,a1
	jsr	-414(a6)		;CloseLibrary(library)(A1)
	movem.l	(a7)+,a1/a6
	rts

AllocMemory:
	movem.l	d1/a6,-(a7)
	move.l	$0004.w,a6
	move.l	#$00000050,d0
	move.l	#$00010000,d1		;Clear
	jsr	-198(a6)		;AllocMem(D0,D1)
	move.l	d0,DirName
	move.l	#$00000050,d0
	move.l	#$00010000,d1		;Clear
	jsr	-198(a6)		;AllocMem(D0,D1)
	move.l	d0,TextBuff
	move.l	#$00000030,d0
	move.l	#$00010000,d1		;Clear
	jsr	-198(a6)		;AllocMem(D0,D1)
	move.l	d0,IOStdReq
	move.l	#$00000022,d0
	move.l	#$00010000,d1		;Clear
	jsr	-198(a6)		;AllocMem(D0,D1)
	move.l	d0,ReplyPort
	move.l	#$00000104,d0
	move.l	#$00010000,d1		;Clear
	jsr	-198(a6)		;AllocMem(D0,D1)
	move.l	d0,FileInfoBlock
	move.l	#$00000240,d0
	move.l	#$00010000,d1		;Clear
	jsr	-198(a6)		;AllocMem(D0,D1)
	move.l	d0,WorkBuff
	move.l	#$00000200,d0
	move.l	#$00010002,d1		;Chip|Clear
	jsr	-198(a6)		;AllocMem(D0,D1)
	move.l	d0,DiskBuff
	movem.l	(a7)+,d1/a6
	rts

FreeMemory:
	movem.l	a1/a6,-(a7)
	move.l	$0004.w,a6
	move.l	DirName,a1
	move.l	#$00000050,d0
	jsr	-210(a6)		;FreeMem(A1,D0)
	move.l	TextBuff,a1
	move.l	#$00000050,d0
	jsr	-210(a6)		;FreeMem(A1,D0)
	move.l	IOStdReq,a1
	move.l	#$00000030,d0
	jsr	-210(a6)		;FreeMem(A1,D0)
	move.l	ReplyPort,a1
	move.l	#$00000022,d0
	jsr	-210(a6)		;FreeMem(A1,D0)
	move.l	FileInfoBlock,a1
	move.l	#$00000104,d0
	jsr	-210(a6)		;FreeMem(A1,D0)
	move.l	WorkBuff,a1
	move.l	#$00000240,d0
	jsr	-210(a6)		;FreeMem(A1,D0)
	move.l	DiskBuff,a1
	move.l	#$00000200,d0
	jsr	-210(a6)		;FreeMem(A1,D0)
	movem.l	(a7)+,a1/a6
	rts

MakeIOStdReq:
	movem.l	a1-a2,-(a7)
	move.l	IOStdReq,a2
	move.b	#$05,$0008(a2)		;ln_Type
	lea	Node_Name(pc),a1
	move.l	a1,$000a(a2)		;ln_Name
	move.l	ReplyPort,$000e(a2)	;mn_ReplyPort
	movem.l	(a7)+,a1-a2
	rts
*************************************************************************
* IOStdReq:
* $0030 sizeof(IOStdReq)
* $0000 io_Message
* $0014 io_Device
* $0018 io_Unit
* $001c io_Command
* $001e io_Flags
* $001f io_Error
* $0020 io_Actual
* $0024 io_Length
* $0028 io_Data
* $002c io_Offset
*************************************************************************
* Message:
* $0014 sizeof(Message)
* $0000 mn_Node
* $000e mn_ReplyPort
* $0012 mn_Length
*************************************************************************
* Node:
* $000e sizeof(Node)
* $0000 ln_Succ
* $0004 ln_Pred
* $0008 ln_Type
* $0009 ln_Pri
* $000a ln_Name
*************************************************************************

MakeReplyPort:
	movem.l	a1-a2/a6,-(a7)
	move.l	ReplyPort,a2
	move.b	#$04,$0008(a2)		;ln_Type
	lea	Node_Name(pc),a1
	move.l	a1,$000a(a2)		;ln_Name
	move.l	$0004.w,a6
	suba.l	a1,a1
	jsr	-294(a6)		;FindTask(name)(A1)
	move.l	d0,$0010(a2)		;mp_SigTask
	moveq	#$ffffffff,d0
	jsr	-330(a6)		;AllocSignal(signalNum)(D0)
	move.b	d0,$000f(a2)		;mp_SigBit
	movem.l	(a7)+,a1-a2/a6
	rts
*************************************************************************
* MsgPort:
* $0022 sizeof(MsgPort)
* $0000 mp_Node
* $000e mp_Flags
* $000f mp_SigBit
* $0010 mp_SigTask
* $0014 mp_MsgList
*************************************************************************
* List:
* $000e sizeof(List)
* $0000 lh_Head
* $0004 lh_Tail
* $0008 lh_TailPred
* $000c lh_Type
* $000d lh_pad
*************************************************************************

OpenTrackDisk:
	movem.l	d1/a1/a6,-(a7)
	move.l	$0004.w,a6
	lea	TD_Name(pc),a0		;devName
	move.l	UnitNr,d0		;unit
	bmi	OpenTrackDisk1
	move.l	IOStdReq,a1		;ioRequest
	moveq	#$01,d1			;flags
	jsr	-444(a6)		;OpenDevice(A0,D0,A1,D1)
OpenTrackDisk1:
	movem.l	(a7)+,d1/a1/a6
	rts

CloseTrackDisk:
	movem.l	a1/a6,-(a7)
	move.l	$0004.w,a6
	move.l	UnitNr,d0
	bmi	CloseTrackDisk1
	move.l	IOStdReq,a1		;ioRequest
	move.w	#$0009,$001c(a1)	;io_Command
	clr.l	$0024(a1)		;io_Length
	jsr	-456(a6)		;DoIO(ioRequest)(A1)
	move.l	IOStdReq,a1		;ioRequest
	jsr	-450(a6)		;CloseDevice(A1)
CloseTrackDisk1:
	move.l	ReplyPort,a1		;MsgPort
	moveq	#$00,d0
	move.b	15(a1),d0		;mp_SigBit
	jsr	-336(a6)		;FreeSignal(D0)
	movem.l	(a7)+,a1/a6
	rts

ReadBlock:			;A0=DiskBlock,D0=Blocknr
	movem.l	a1/a6,-(a7)
	move.l	$4,a6			;ExecBase
	move.l	IOStdReq,a1		;ioRequest
	move.w	#$0002,$001c(a1)	;io_Command
	move.b	#$01,$001e(a1)		;io_Flags
	move.l	#$00080000,$0024(a1)	;io_Length
	move.l	a0,$0028(a1)		;io_Data
	move.l	d0,$002c(a1)		;io_Offset
	jsr	-456(a6)		;DoIO(ioRequest)(A1)
	movem.l	(a7)+,a1/a6
	rts

Node_Name:
	dc.b	"FastList",0
TD_Name:
	dc.b	"hddisk.device",0
DOS_Name:
	dc.b	"dos.library",0
INTUITION_Name:
	dc.b	"intuition.library",0
	even

UnitNr:
	dc.l	$ffffffff
CursorX:
	dc.w	0
NrFiles:
	dc.l	0
NrDirs:
	dc.l	0
NrBlocks:
	dc.l	0
DosBase:
	dc.l	0
IntuitionBase:
	dc.l	0
Output:
	dc.l	0
ThisLock:
	dc.l	0
DirName:
	dc.l	0		;$0050 bytes
TextBuff:
	dc.l	0		;$0050 bytes
FileInfoBlock:
	dc.l	0		;$0104 bytes
WorkBuff:
	dc.l	0		;$0240 bytes
DiskBuff
	dc.l	0		;$0200 bytes chipmem
IOStdReq:
	dc.l	0		;$0030 bytes
ReplyPort:
	dc.l	0		;$0022 bytes


