*--------------------------------------------------------------------*
*                        COPPERLISTROUTINE         		     *
*--------------------------------------------------------------------*
	Section	Code,Code_F
code:	move.l	$4.W,a6
	movem.l	a0-a6/d0-d7,-(a7)
	bsr	FixTitle
	bsr	FixTrain
	lea	Gfx_Name,a1
	jsr	-408(a6)
	move.l	d0,a6
	lea	CopperList,a1
	lea	Copper,a2
	lea	$dff096,a5
	move.w	#$0020,(a5)
	move.l	$32(a6),-(a7)
	move.l	a2,$32(a6)
copy:	move.w	(a1),(a2)+
	cmp.w	#$a200,(a1)+
	bne.s	copy
	bsr	FixCopper
myros:	movem.w	(a1)+,d0-d3
	bsr.s	myrskit
	bsr.s	myrskit3
	bsr.s	myrskit1
	bsr.s	myrskit3
	sub.w	d2,d1
	moveq	#$03,d4
myris:	bsr.s	myrskit2
	bsr.s	myrskit3
	dbf	d4,myris
	bsr.s	myrskit1
	bsr.s	myrskit3
	bsr.s	myrskit1
	bsr.s	myrskit3
	clr.w	d1
	bsr.s	myrskit
	cmp.b	#$03,d0
	bne.s	myros
	move.l	#$fffffffe,(a2)+
	bra  	init
myrskit1:
	sub.w	d2,d1
myrskit:
	move.w	d0,(a2)+
	move.l	#$fffe0180,(a2)+
	move.w	d1,(a2)+
	add.w	#$0100,d0
	rts
myrskit2:
	bsr.s	myrskit
	move.w	#$0182,(a2)+
	move.w	d3,(a2)+
	move.w	#$0186,(a2)+
	move.w	d3,(a2)+
	sub.w	#$0110,d3
	bsr.s	myrskit3
	add.w	#$0100,d0
	rts

myrskit3:
	move.w	d0,d5
	sub.w	#$0100,d5
	cmp.w	#$7800,d5
	bcs.s	nomenubars
	cmp.w	#$f400,d5
	bcc.s	nomenubars
	move.b	#$47,d5
	move.w	d5,(a2)+
	move.l	#$fffe0180,(a2)+
	move.w	d1,(a2)+
	move.b	#$71,d5
	move.w	d5,(a2)+
	move.l	#$fffe0180,(a2)+
	move.w	d1,(a2)+

	move.b	#$7b,d5
	move.w	d5,(a2)+
	move.l	#$fffe0180,(a2)+
	move.w	d1,(a2)+
	move.b	#$a5,d5
	move.w	d5,(a2)+
	move.l	#$fffe0180,(a2)+
	move.w	d1,(a2)+

	move.b	#$b1,d5
	move.w	d5,(a2)+
	move.l	#$fffe0180,(a2)+
	move.w	d1,(a2)+
	move.b	#$db,d5
	move.w	d5,(a2)+
	move.l	#$fffe0180,(a2)+
	move.w	d1,(a2)+
nomenubars:
	rts

*--------------------------------------------------------------------*
*                          INITIATIONROUTINE                         *
*--------------------------------------------------------------------*
init:	
	move.l	#$00000100,$100.W
	lea	Bitplanes,a4
	lea     PlaneStruct,a0
	move.l	a0,a2
	moveq	#01,d0
	move.w  #768,d1
	move.w  #256,d2
	jsr     -390(a6)
	move.l  a4,8(a2)
	lea     RastPort,a1
	move.l	a1,a3
	move.l	a2,a0
	jsr     -198(a6)
	move.l  a2,4(a3)
	moveq	#01,d0
	move.l	a3,a1
	move.l	a2,a0
	jsr	-342(a6)
	move.w	#$8380,(a5)
	bsr  	showmenu
	lea	LastYMouse,a0
	move.b	$dff00a,(a0)
	lea	BarText,a2
	clr.w	d3
print:	moveq	#56*2,d2
	move.b	(a2)+,d3
	beq.s	firstloop
	moveq	#79,d4
	bsr  	write
	adda.w	#79,a2
	bra.s	print
firstloop:
	bsr  	updatemenu
	bra.s	skroll
Subr:	clr.l	$72(a5)
	clr.l	$ae(a5)
	subq.w	#1,d7
	bne.s	scrollbar

*--------------------------------------------------------------------*
*                          SCROLLROUTINE                             *
*--------------------------------------------------------------------*
	move.b	(a2),d0
	bne.s	good
skroll	lea	ScrollText,a2		; Restart Text
good	move.w	#374+384,d2
	move.w	#$f0,d3
	moveq	#$01,d4
	bsr  	write
	addq.l	#1,a2
	moveq	#$02,d7

scrollbar:
*--------------------------------------------------------------------*
*                          SCROLLROUTINE                             *
*--------------------------------------------------------------------*
	move.l	a3,a1		; Scroll Screen
	moveq	#04,d0
	moveq	#00,d1
	moveq	#00,d2
	move.w	#$f4-10,d3
	move.w	#768,d4
	move.w	#$f4-2,d5
	jsr	-396(a6)

*--------------------------------------------------------------------*
*                     KEY SELECTION DETECTION                        *
*--------------------------------------------------------------------*
	move.b	$bfec01,d2
	not.b	d2
	move.b	d2,d3
	lsr.w	#1,d2
	cmp.b	#$28,d2
	bcc.s	checkmousemove
	moveq	#$10,d1
	cmp.b	#$20,d2
	bcc.s	validkey
	cmp.b	#$18,d2
	bcc.s	checkmousemove
	moveq	#$08,d1
	cmp.b	#$10,d2
	bcc.s	validkey
	cmp.b	#$09,d2
	bcc.s	checkmousemove
	moveq	#$01,d1
	cmp.b	#$01,d2
	bcs.s	checkmousemove
validkey:
	sub.b	d1,d2
	lea	MenuNr,a0
	cmp.b	(a0),d2
	beq.s	samekeyasbef
	btst	#0,d3
	bne.s	samekeyasbef
	lea	LastYMouse,a0
	move.b	$dff00a,(a0)
	bsr  	remmenu
	lea	MenuNr,a0
	move.b	d2,(a0)
	bsr  	showmenu
samekeyasbef:
	lsr.w	#1,d3
	bcc.s	keypresseddown
	lea	Keybutton,a0
	move.w	#$ffff,(a0)
	bra.s	checkmousemove
keypresseddown:
	lea	Keybutton,a0
	bra.s	keypress2		

checkmousemove:
	move.b	$dff00a,d3
	lea	LastYMouse,a0
	move.b	(a0),d2
	move.b	d3,d4
	sub.b	d2,d3
	addq.b	#8,d3
	asr.b	#4,d3
	cmp.b	#$00,d3
	beq.s	checkmousebut
	move.b	d4,(a0)
	add.b	MenuNr,d3
	bpl.s	mod18
	sub.b	#$10,d3
mod18:	sub.b	#$18,d3
	bcc.s	mod18
	add.b	#$18,d3
	bsr  	remmenu
	lea	MenuNr,a0
	move.b	d3,(a0)
	bsr  	showmenu
checkmousebut:
	btst	#6,$bfe001
	beq.s	mousebutdown
	lea	Mousebutton,a0
	move.w	#$ffff,(a0)
	bra.s	wait	
mousebutdown:
	lea	Mousebutton,a0
keypress2:
	move.w	(a0),d0
	addq.w	#1,(a0)
	cmp.w	#$0020,d0
	bne.s	mousebut2
	move.w	#$001a,(a0)
	bra.s	changemenu
mousebut2:
	tst.w	d0
	bne.s	wait
changemenu:
	lea	MenuNr,a0	
	clr.l	d2
	move.b	(a0),d2
	lea	$100.w,a0
	lea	MenuModes,a1
	move.b	0(a1,d2.w),d1
	bne.s	changem2
	or.b	#$01,0(a0,d2.w)
	and.b	#$01,0(a0,d2.w)
	bra.s	exit
changem2:
	cmp.b	#$01,d1
	bne.s	changem3
	eor.b	#$01,0(a0,d2.w)
	and.b	#$01,0(a0,d2.w)
	bra.s	changem4
changem3:
	move.b	0(a0,d2.w),d0
	sub.b	$18(a1,d2.w),d0
	addq.b	#1,d0
modd1:	sub.b	d1,d0
	bcc.s	modd1
	add.b	d1,d0
	add.b	$18(a1,d2.w),d0
	move.b	d0,0(a0,d2.w)
changem4:
	bsr  	updatemenud2

wait:	tst.b	-$90(a5)
	bmi	wait
.1	tst.b 	-$90(a5)
	bpl	.1
	bra  	Subr

*--------------------------------------------------------------------*
*                          ENDINGROUTINE                             *
*--------------------------------------------------------------------*
exit:	move.l  (a7)+,$32(a6)
	move.w  #$8020,(a5)
	movem.l	(a7)+,a0-a6/d0-d7
	moveq	#$00,d0
	rts

*--------------------------------------------------------------------*
*                        PRINTSTRINGROUTINE                          *
*--------------------------------------------------------------------*
write:	
	move.l	a3,a1
	move.l	d2,d0
	move.l	d3,d1
	jsr	-240(a6)
	move.l	a2,a0
	move.l	a3,a1
	move.l	d4,d0
	move.l	d3,d1
	jsr	-60(a6)
	rts

*--------------------------------------------------------------------*
*                           MENUROUTINES                             *
*--------------------------------------------------------------------*
showmenu:
	lea	Copper,a0
	move.b	MenuNr,d0
	move.b	d0,d1
	and.w	#$0007,d0
	mulu	#$0e00,d0
	add.w	#$7800,d0
	lsr.b	#3,d1
	move.b	#$47,d0
	cmp.b	#$00,d1
	beq.s	showmenu1
	move.b	#$7b,d0
	cmp.b	#$01,d1
	beq.s	showmenu1
	move.b	#$b1,d0
showmenu1:
	swap	d0
	move.w	#$fffe,d0
	moveq	#$0b,d1		;12 rasters
showmenu2:
	cmp.l	(a0)+,d0
	bne.s	showmenu2
	add.w	#$0220,2(a0)
	add.l	#$01000000,d0
	dbf	d1,showmenu2
	rts

remmenu:
	lea	Copper,a0
	move.b	MenuNr,d0
	move.b	d0,d1
	and.w	#$0007,d0
	mulu	#$0e00,d0
	add.w	#$7800,d0
	lsr.b	#3,d1
	move.b	#$47,d0
	cmp.b	#$00,d1
	beq.s	remmenu1
	move.b	#$7b,d0
	cmp.b	#$01,d1
	beq.s	remmenu1
	move.b	#$b1,d0
remmenu1:
	swap	d0
	move.w	#$fffe,d0
	moveq	#$0b,d1		;12 rasters
remmenu2:
	cmp.l	(a0)+,d0
	bne.s	remmenu2
	sub.w	#$0220,2(a0)
	add.l	#$01000000,d0
	dbf	d1,remmenu2
	rts

updatemenud2:
	move.l	a2,-(a7)
	moveq	#$00,d5
	move.b	d2,d5
	move.l	d5,d6
	addq.b	#1,d6
	bra.s	updatem6
updatemenu:
	move.l	a2,-(a7)
	moveq	#$00,d5
	moveq	#$18,d6
updatem6:
	lea	$0100.w,a0
	lea	MenuModes,a1
	moveq	#$00,d0
	move.b	0(a0,d5.w),d0
	move.b	0(a1,d5.w),d1
	beq.s	updatem4
	cmp.b	#$01,d1
	bne.s	updatem3
	lea	OffText,a2
	moveq	#$03,d4
	tst.b	d0
	beq.s	updatem2
	lea	OnText,a2
	moveq	#$03,d4
	bra.s	updatem2
updatem3:
	lea	NrText,a2
	moveq	#$02,d4
mod100:	sub.w	#$0064,d0
	bcc.s	mod100
	add.w	#$0064,d0
	divu	#$000a,d0
	addi.l	#$00300030,d0
	move.b	d0,(a2)
	swap	d0
	move.b	d0,1(a2)
updatem2:
	move.l	d5,d3
	and.w	#$0007,d3
	mulu	#$000e,d3
	add.w	#$0074,d3
	move.l	d5,d1
	divu	#$0008,d1
	move.w	#$0120,d2
	tst.w	d1
	beq.s	updatem5
	move.w	#$01f0,d2
	cmp.b	#$01,d1
	beq.s	updatem5
	move.w	#$02c0,d2
updatem5:
	bsr  	write
updatem4:
	addq.l	#1,d5
	cmp.b	d6,d5
	bne  	updatem6
	move.l	(a7)+,a2
	rts

FixCopper
	lea	Bitplanes,a0
	move.l	a0,d0
	move.l	a0,d1
	add.l	#$0c00,d0
	add.l	#$0ba0,d1
	move.w	d0,Copper+$1e
	move.w	d1,Copper+$26
	swap	d0
	swap	d1
	move.w	d0,Copper+$1a
	move.w	d1,Copper+$22
	rts

FixTitle
	movem.l	d0-d7/a0-a6,-(a7)
	lea	BarText,a0
	lea	TitleText,a1
.1	addq.l	#1,a0
	tst.b	(a1)
	beq	.5
	moveq	#-1,d0
.2	addq.l	#1,d0
	tst.b	0(a1,d0.w)
	bne	.2
	move.w	#79,d1
	sub.w	d0,d1
	move.w	d1,d0
	lsr.w	#1,d0
.3	move.b	(a1)+,d1
	beq	.4
	move.b	d1,0(a0,d0.w)
	addq.l	#1,d0
	bra	.3
.4	lea	79(a0),a0
	bra	.1
.5	movem.l	(a7)+,d0-d7/a0-a6
	rts

FixTrain
	movem.l	d0-d7/a0-a6,-(a7)
	lea	BarSelText,a0
	lea	TrainText,a1
	moveq	#$07,d2
	moveq	#5,d1
.1
	move.b	(a1)+,d0
	bne	.2
	lea	TrainTextDef,a2
	bsr	.Copy
	bra	.3
.2	lea	-1(a1),a2
	bsr	.Copy
	move.l	a2,a1
.3	move.w	d1,d0
	moveq	#32,d1
	cmp.w	#5,d0
	beq	.1
	moveq	#58,d1
	cmp.w	#32,d0
	beq	.1
	moveq	#5,d1
	lea	80(a0),a0
	dbf	d2,.1
	movem.l	(a7)+,d0-d7/a0-a6
	rts
.Copy	move.l	d1,d3
.4	move.b	(a2)+,d0
	beq	.5
	move.b	d0,0(a0,d3.w)
	addq.l	#1,d3
	bra	.4
.5	rts


	Section	Data,Data_F
*--------------------------------------------------------------------*
*                         COPPERLIST                                 *
******* dc.w    copperinstructions,$0100,$2200 ***********************
*--------------------------------------------------------------------*
CopperList
	dc.w	$0100,$0200,$0102,$0010
	dc.w	$0092,$0020,$0094,$00d8
	dc.w	$008e,$2020,$0090,$2ce0
	dc.w	$00e0,$0007,$00e2,$0c00
	dc.w	$00e4,$0007,$00e6,$0ba0
	dc.w	$0180,$0000,$0184,$0000
	dc.w	$2c01,$fffe,$0100,$a200

*--------------------------------------------------------------------*
*                            BARDATA                                 *
******* dc.w    linenr,barcolor,shading,textcolor ********************
*--------------------------------------------------------------------*
BarData
	dc.w	$3201,$0aac,$0111,$0ccb
	dc.w	$4001,$0aac,$0111,$0ccb
	dc.w	$4e01,$0bbd,$0111,$0ddc
	dc.w	$5c01,$0bbd,$0111,$0ddc
	dc.w	$6a01,$0cce,$0111,$0eed
	dc.w	$7801,$0cce,$0111,$0eed
	dc.w	$8601,$0ddf,$0111,$0ffe
	dc.w	$9401,$0cce,$0111,$0eed
	dc.w	$a201,$0cce,$0111,$0eed
	dc.w	$b001,$0bbd,$0111,$0ddc
	dc.w	$be01,$0bbd,$0111,$0ddc
	dc.w	$cc01,$0aac,$0111,$0ccb
	dc.w	$da01,$0aac,$0111,$0ccb
	dc.w	$f403,$0a8c,$0110,$0fde	;Do NOT remove this line!

*--------------------------------------------------------------------*
*                         SELECTIONTEXT                              *
******* dc.b 	linenr/2+1,79 letters of text ************************
*--------------------------------------------------------------------*
BarText
	dc.b	$32-4,"                                                  "
	dc.b	"                             "
	dc.b	$40-4,"                                                  "
	dc.b	"                             "
	dc.b	$4e-4,"                                                  "
	dc.b	"                             "
	dc.b	$5c-4,"                                                  "
	dc.b	"                             "
	dc.b	$6a-4," Use Mouse & left mouse button , or , Keyboard key"
	dc.b	"s to change trainer options. "
;                      01234567890123456789012345678901234567890123456789
BarSelText
	dc.b	$78-4,"(1)                        (Q)                    "
;                012345678
	dc.b	"   (A)                       "
	dc.b	$86-4,"(2)                        (W)                    "
	dc.b	"   (S)                       "
	dc.b	$94-4,"(3)                        (E)                    "
	dc.b	"   (D)                       "
	dc.b	$a2-4,"(4)                        (R)                    "
	dc.b	"   (F)                       "
	dc.b	$b0-4,"(5)                        (T)                    "
	dc.b	"   (G)                       "
	dc.b	$be-4,"(6)                        (Y)                    "
	dc.b	"   (H)                       "
	dc.b	$cc-4,"(7)                        (U)                    "
	dc.b	"   (J)                       "
	dc.b	$da-4,"(8)                        (I)                    "
	dc.b	"   (K)                       "
	dc.b	0
TitleText
	dc.b	"DEFJAM-CCS PROUDLY PRESENTS",0
	dc.b	"PROJECT X Harddiskversion",0
	dc.b	"MADE BY PHS",0
	dc.b	"Originally cracked by NEMESIS",0
	dc.b	0

TrainText
	dc.b	"Infinite lives",0,0,0
	dc.b	"Anti crash",0,0,0
	dc.b	"Start level",0,0,0
	dc.b	0,0,0

	dc.b	0,0,0
	dc.b	0,0,0
	dc.b	0,0,0
	dc.b	0,0,0
	
TrainTextDef
	dc.b	"Start game",0

*--------------------------------------------------------------------*
*                         SELECTIONMODES                             *
*--------------------------------------------------------------------*
MenuModes
	dc.b	1,1,6,0,0,0,0,0		; "12345678"
	dc.b	0,0,0,0,0,0,0,0		; "QWERTYUI"
	dc.b	0,0,0,0,0,0,0,0		; "ASDFGHJK"

	dc.b	0,0,1,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0,0
	
				;0 just exit from menu
				;1 turn on/off
				;2 or more, max numbers (2 digits)
			;The result is placed on address $100
			;and forward, 0 for off, 1 for on or 
			;number if specified above.

*--------------------------------------------------------------------*
*                           SCROLLTEXT                               *
******* dc.b 	letters of scrolltext,0 ******************************
*--------------------------------------------------------------------*
ScrollText
	dc.b	"DEFJAM-CCS PROUDLY PRESENTS: PROJECT X FROM TEAM 17. "
	dc.b	"HARDDISKVERSION BY PHS. ORIGINALLY CRACKED BY NEMESIS. "
	dc.b	0

*--------------------------------------------------------------------*
*                          SYSTEMVARIABELS                           *
*--------------------------------------------------------------------*

OnText
	dc.b	"ON "
OffText
	dc.b	"OFF"
Gfx_Name
	dc.b	"graphics.library",0
NrText
	dc.b	"00"

	Section	BSS1,BSS_F
RastPort
	ds.l	$100/4
PlaneStruct
	ds.l	$100/4
Mousebutton
	ds.w	1
Keybutton
	ds.w	1
MenuNr
	ds.b	1
LastYMouse
	ds.b	1

	Section	BSS2,BSS_C
Copper
	ds.l	$2000/4
Bitplanes
	ds.l	$6C00/4
