	Section	AutoBoot,Code
	Include	exec/exec.i
	Include	exec/execbase.i
	Include	exec/exec_lib.i
	Include libraries/expansion.i
	Include	libraries/expansionbase.i
	Include	libraries/expansion_lib.i
	Include	libraries/configregs.i

FindA2090Board
	movem.l	d2-d7/a2-a6,-(a7)
	lea	ExpName(pc),a1
	moveq	#$00,d0
	move.l	$4,a6
	jsr	_LVOOldOpenLibrary(a6)
	tst.l	d0
	beq	.Error
	move.l	d0,a4

	move.l	a4,a6
	jsr	_LVOObtainConfigBinding(a6)

	lea	eb_Private05-LN_SUCC(a4),a0
.Again
	move.l	LN_SUCC(a0),d0
	beq	.Error
	move.l	d0,a0
	cmp.w	#514,er_Manufacturer+cd_Rom(a0)
	bne	.Again
	cmp.b	#1,er_Product+cd_Rom(a0)
	bne	.Again
.Found
	move.l	a0,eb_Private04(a4)

	move.l	a4,a6
	jsr	_LVOReleaseConfigBinding(a6)

	move.l	a4,a1
	move.l	$4,a6
	jsr	_LVOCloseLibrary(a6)

	moveq	#-1,d0
	movem.l	(a7)+,d2-d7/a2-a6
	rts
.Error
	moveq	#$00,d0
	movem.l	(a7)+,d2-d7/a2-a6
	rts
		

AddBootNode				;A0=DeviceNode,A1=ConfigDev
	movem.l	d2-d7/a2-a6,-(a7)
	move.l	a0,a2
	move.l	a1,a3

	lea	ExpName(pc),a1
	moveq	#33,d0
	move.l	$4,a6
	jsr	_LVOOpenLibrary(a6)
	tst.l	d0
	beq	.Error
	move.l	d0,a4

	move.l	a4,a6
	jsr	_LVOObtainConfigBinding(a6)

	lea	DiagStart(pc),a0
	move.l	a0,er_Reserved0c+cd_Rom(a3)
	or.b	#$10,er_Type+cd_Rom(a3)

	move.l	#$14,d0
	move.l	#$00010001,d1
	move.l	$4,a6
	jsr	_LVOAllocMem(a6)
	tst.l	d0
	beq	.Error
	move.l	d0,a1

	move.b	#NT_BOOTNODE,LN_TYPE(a1)
	move.b	#$00,LN_PRI(a1)
	move.l	a3,LN_NAME(a1)		;ConfigDev->BootNode.???
	move.w	#$0000,bn_Flags(a1)
	move.l	a2,bn_DeviceNode(a1)		;DosNode->bn_DeviceNode

	lea	eb_MountList(a4),a0
	move.l	$4,a6
	jsr	_LVOEnqueue(a6)

	move.l	a4,a6
	jsr	_LVOReleaseConfigBinding(a6)

	move.l	a4,a1
	move.l	$4,a6
	jsr	_LVOCloseLibrary(a6)
	moveq	#-1,d0
	movem.l	(a7)+,d2-d7/a2-a6
	rts
.Error
	move.l	$4,a6
	moveq	#-1,d7
	jsr	_LVOAlert(a6)
	movem.l	(a7)+,d2-d7/a2-a6
	rts
	

DiagStart
	dc.b	DAC_WORDWIDE+DAC_CONFIGTIME
	dc.b	0
	dc.w	EndCopy-DiagStart
	dc.w	0
	dc.w	BootEntry-DiagStart
	dc.w	0
	dc.w	0
	dc.w	0

DosName	dc.b	"dos.library",0
	even

BootEntry
	lea	ExpName(pc),a1
	moveq	#37,d0
	jsr	_LVOOpenLibrary(a6)
	tst.l	d0
	beq	.OldExpLib
	move.l	d0,a1
	bset	#EBB_SILENTSTART,eb_Flags(a1)
	jsr	_LVOCloseLibrary(a6)
.OldExpLib
	lea	DosName(pc),a1
	jsr	_LVOFindResident(a6)
	move.l	d0,a0
	move.l	RT_INIT(a0),a0
	jsr	(a0)
	rts
EndCopy

ExpName	EXPANSIONNAME
