	Section	Startup,Code_F
	Incdir	DEVPAC:include/
	Include	exec/execbase.i
	Include	exec/exec_lib.i
	Include	libraries/dos.i
	Include	libraries/dos_lib.i

Start
	bsr	OpenLibraries
	bsr	WriteHey
	bsr	AllocMemory
	tst.l	d0
	beq	.End
	lea	$58000,a1
	moveq	#$00,d0
	moveq	#$00,d1
	moveq	#$00,d2
	bsr	LoadFile
	move.l	a7,UserStack
	CALLEXEC	Forbid
	CALLEXEC	SuperState
	move.l	SuperStack,a7
	move.w	$dff01c,SaveIRQEna1
	move.w	#$7fff,$dff09a
	lea	SaveCIARegs1,a0
	bsr	ReadCIA
	move.w	#$0180,$dff096
	bsr	SwapMemory
	move.l	GameExtraMem,a0
	move.l	a0,$0200.W
	move.l	#LoadVector,$00BC.W
	jmp	$58000

.End	bsr	WriteShit
	move.l	#121,d0
	rts

LoadVector
	move.w	#$2700,SR
	move.w	$dff01c,SaveIRQEna2
	move.w	#$7fff,$dff09a
.1	btst	#6,$dff002
	bne.s	.1
	move.l	a7,SaveStack
	move.l	SuperStack,a7
	movem.l	d0-d7/a0-a6,-(a7)
	move.l	a3,a0
	bsr	CheckCopper
	tst.l	d0
	beq	.2
	move.w	#$0180,$dff096
.2	movem.l	(a7)+,d0-d7/a0-a6
	movem.l	d0-d7/a0-a6,-(a7)
	move.l	a1,a5
	move.l	d0,d5
	move.l	d1,d6
	move.l	d2,d7
	lea	SaveCIARegs2,a0
	bsr	ReadCIA
	bsr	SwapMemory
	lea	SaveCIARegs1,a0
	bsr	WriteCIA
	move.w	#$2000,SR
	move.l	UserStack,d0
	CALLEXEC	UserState
	tst.b	$bfed01
	tst.b	$bfdd00
	move.w	#$7fff,$dff09c
	move.w	SaveIRQEna1,d0
	or.w	#$8000,d0
	move.w	d0,$dff09a
	bsr	LittleWait
	move.l	a5,a1
	move.l	d5,d0
	move.l	d6,d1
	move.l	d7,d2
	bsr	LoadFile
	move.l	d0,ReturnValue
	CALLEXEC	SuperState
	move.w	#$2700,SR
	move.w	#$7fff,$dff09a
	bsr	SwapMemory
	lea	SaveCIARegs2,a0
	bsr	WriteCIA
	move.w	#$8180,$dff096
	tst.w	$dff088
	movem.l	(a7)+,d0-d7/a0-a6
	move.l	SaveStack,a7
	tst.b	$bfed01
	tst.b	$bfdd00
	move.w	#$7fff,$dff09c
	move.w	SaveIRQEna2,d0
	or.w	#$8000,d0
	move.w	d0,$dff09a
	move.l	ReturnValue,d0
	rte
	
LittleWait
	move.w	#$3fff,d0
.1	dbf	d0,.1
	rts
	
AllocMemory
	movem.l	d2-d7/a2-a6,-(a7)
	lea	$7e800,a3
	move.l	a3,a1
	move.l	#$2800,d0
	CALLEXEC	AllocAbs
	lea	$18000,a2
.1
	move.l	a2,a1
	move.l	a3,d0
	sub.l	a2,d0
	CALLEXEC	AllocAbs
	tst.l	d0
	bne	.2
	lea	$800(a2),a2
	cmp.l	a2,a3
	bne	.1
	moveq	#$00,d0
	bra	.3
.2
	move.l	a2,ChipCopyEnd
	move.l	a2,d0
	move.l	#$10000,d1
	CALLEXEC	AllocMem
	tst.l	d0
	beq	.3
	move.l	d0,ChipCopyMem

	move.l	#$80000,d0
	move.l	#$10000,d1
	CALLEXEC	AllocMem
	tst.l	d0
	beq	.3
	move.l	d0,GameExtraMem

	move.l	#$2800,d0
	move.l	#$10000,d1
	CALLEXEC	AllocMem
	tst.l	d0
	beq	.3
	add.l	#$27f0,d0
	move.l	d0,SuperStack
.3
	movem.l	(a7)+,d2-d7/a2-a6
	rts

SwapMemory
	move.l	a2,-(a7)
	lea	$0000.W,a0
	move.l	ChipCopyMem,a1
	move.l	ChipCopyEnd,a2
.1	move.l	(a0),d0
	move.l	(a1),d1
	move.l	d0,(a1)+
	move.l	d1,(a0)+
	cmp.l	a0,a2
	bne	.1
	move.l	(a7)+,a2
	rts

WriteHey
	movem.l	d2-d7/a2-a6,-(a7)
	move.l	#WindowName,d1
	move.l	#MODE_OLDFILE,d2
	CALLDOS	Open
	tst.l	d0
	beq	.2
	move.l	d0,d1
	move.l	#HeyText,d2
	move.l	#HeyTextEnd-HeyText,d3
	CALLDOS Write
.1	btst	#7,$bfe001
	bne	.1
.2	movem.l	(a7)+,d2-d7/a2-a6
	rts
	
WriteShit
	movem.l	d2-d7/a2-a6,-(a7)
	move.l	#WindowName,d1
	move.l	#MODE_OLDFILE,d2
	CALLDOS	Open
	tst.l	d0
	beq	.2
	move.l	d0,d1
	move.l	#ShitText,d2
	move.l	#ShitTextEnd-ShitText,d3
	CALLDOS Write
.2	movem.l	(a7)+,d2-d7/a2-a6
	rts

LoadFile
	movem.l	d2-d7/a2-a6,-(a7)
	clr.l	d4
	move.l	a1,a2
	move.l	ChipCopyEnd,a3
	move.l	ChipCopyMem,a4
	move.l	d1,d6
	move.l	d2,d7
	move.w	d0,d1
	lsr.w	#8,d0
	and.w	#$000f,d0
	add.b	#$31,d0
	move.b	d0,FileName
	move.w	d1,d0
	lsr.w	#4,d0
	and.w	#$000f,d0
	add.b	#$30,d0
	move.b	d0,FileName+1
	and.b	#$0f,d1
	cmp.b	#$09,d1
	bls	.1
	add.b	#$11-$0a,d1
.1	add.b	#$30,d1
	move.b	d1,FileName+2
	clr.b	FileName+3
	move.l	#FileName,d1
	move.l	#MODE_OLDFILE,d2
	CALLDOS	Open
	tst.l	d0
	beq	.3
	move.l	d0,d5
	tst.l	d7
	beq.s	.4
	move.l	d5,d1
	move.l	d7,d2
	move.l	#OFFSET_BEGINNING,d3
	CALLDOS	Seek
.4	tst.l	d6
	bne.s	.5
	move.l	d5,d1
	cmp.l	a2,a3
	bls	.2
	move.l	a2,d2
	add.l	a4,d2
	move.l	a3,d3
	sub.l	a2,d3
	CALLDOS	Read
	add.l	d0,d4
	move.l	a3,a2
.2	move.l	a2,d2
	move.l	#$80000,d3
	move.l	d5,d1
	CALLDOS Read
	add.l	d0,d4
	move.l	d5,d1
	CALLDOS Close
.3	move.l	d4,d0
	movem.l	(a7)+,d2-d7/a2-a6
	rts
.5
	move.l	a2,a5
	add.l	d6,a5
	cmp.l	a2,a3
	bls	.6
	cmp.l	a3,a5
	bhi	.7
	move.l	a2,d2
	add.l	a4,d2
	move.l	d6,d3
	move.l	d5,d1
	CALLDOS	Read
	add.l	d0,d4
	move.l	d5,d1
	CALLDOS Close
	bra	.3
.7
	move.l	a2,d2
	add.l	a4,d2
	move.l	a3,d3
	sub.l	a2,d3
	move.l	d5,d1
	CALLDOS	Read
	add.l	d0,d4
	move.l	a3,a2
.6
	move.l	a2,d2
	move.l	a5,d3
	sub.l	a2,d3
	move.l	d5,d1
	CALLDOS Read
	add.l	d0,d4
	move.l	d5,d1
	CALLDOS Close
	bra	.3

CheckCopper
	movem.l	d2-d7/a2-a6,-(a7)
	move.l	ChipCopyEnd,a3
	lea	$2000(a0),a1
	cmp.l	a0,a3
	bhi	.No
	clr.l	Bitplanes
	clr.l	Bitplanes+4
	move.l	a3,Bitplanes+8
	move.l	a3,Bitplanes+12
	move.l	a3,Bitplanes+16
	move.l	a3,Bitplanes+20
.Loop
	move.w	(a0)+,d0
	move.w	(a0)+,d1
	cmp.w	#$FFFF,d0
	beq	.Test
	cmp.w	#$008a,d0
	beq	.Test
	cmp.l	a1,a0
	beq	.Test
	cmp.w	#$00e0,d0
	bne.s	.1
	move.w	d1,Bitplanes
.1	
	cmp.w	#$00e2,d0
	bne.s	.2
	move.w	d1,Bitplanes+2
.2	
	cmp.w	#$00e4,d0
	bne.s	.3
	move.w	d1,Bitplanes+4
.3	
	cmp.w	#$00e6,d0
	bne.s	.4
	move.w	d1,Bitplanes+6
.4	
	cmp.w	#$00e8,d0
	bne.s	.5
	move.w	d1,Bitplanes+8
.5	
	cmp.w	#$00ea,d0
	bne.s	.6
	move.w	d1,Bitplanes+10
.6	
	cmp.w	#$00ec,d0
	bne.s	.7
	move.w	d1,Bitplanes+12
.7	
	cmp.w	#$00ee,d0
	bne.s	.8
	move.w	d1,Bitplanes+14
.8	
	cmp.w	#$00f0,d0
	bne.s	.9
	move.w	d1,Bitplanes+16
.9
	cmp.w	#$00f2,d0
	bne.s	.10
	move.w	d1,Bitplanes+18
.10
	cmp.w	#$00f4,d0
	bne.s	.11
	move.w	d1,Bitplanes+20
.11
	cmp.w	#$00f6,d0
	bne.s	.12
	move.w	d1,Bitplanes+22
.12

.Test
	cmp.l	Bitplanes,a3
	bhi	.No
	cmp.l	Bitplanes+4,a3
	bhi	.No
	cmp.l	Bitplanes+8,a3
	bhi	.No
	cmp.l	Bitplanes+12,a3
	bhi	.No
	cmp.l	Bitplanes+16,a3
	bhi	.No
	cmp.l	Bitplanes+20,a3
	bhi	.No
.Ok
	moveq	#$00,d0
	movem.l	(a7)+,d2-d7/a2-a6
	rts
.No
	moveq	#-1,d0
	movem.l	(a7)+,d2-d7/a2-a6
	rts

OpenLibraries
	lea	DosName(pc),a1
	moveq	#$00,d0
	CALLEXEC	OldOpenLibrary
	move.l	d0,_DOSBase
	rts

ReadCIA					;Reads the CIA registers
	movem.l	d0-d4/a0-a2,-(a7)
	lea	$bfd000,a1		;CIAB Hardware address
	lea	$dff000,a2
	move.w	#$2000,d2		;EXTER
	bsr.s	ReadCIA1
	lea	$18(a0),a0
	lea	$bfe001,a1		;CIAA Hardware address
	move.w	#$0008,d2		;PORTS
	bsr.s	ReadCIA1
	movem.l	(a7)+,d0-d4/a0-a2
	rts
ReadCIA1
	move.b	$000(a1),$0(a0)		;PRA
	move.b	$100(a1),$1(a0)		;PRB
	move.b	$200(a1),$2(a0)		;DDRA
	move.b	$300(a1),$3(a0)		;DDRB
	move.b	$e00(a1),$e(a0)		;CRA
	move.b	$f00(a1),$f(a0)		;CRB
	moveq	#$00,d4
	move.b	d4,$e00(a1)	;turn off timer a
	move.b	d4,$f00(a1)	;turn off timer b
	move.b	$400(a1),$4(a0)		;TALO
	move.b	$500(a1),$5(a0)		;TAHI
	move.b	$600(a1),$6(a0)		;TBLO
	move.b	$700(a1),$7(a0)		;TBHI
	move.b	$a00(a1),$a(a0)		;Event MSB
	move.b	$900(a1),$9(a0)		;Event 8-15
	move.b	$800(a1),$8(a0)		;Event LSB
	move.b	$c00(a1),$c(a0)		;SDR
	move.b	$d00(a1),$14(a0)	;ICR request
	move.b	#$10,$e00(a1)	;force load timer a
	move.b	#$10,$f00(a1)	;force load timer a
	move.b	$400(a1),$10(a0)	;TALO latch
	move.b	$500(a1),$11(a0)	;TAHI latch
	move.b	$600(a1),$12(a0)	;TBLO latch
	move.b	$700(a1),$13(a0)	;TBHI latch
	moveq	#$00,d1
	move.b	#$10,$d00(a1)
	move.b	d4,$a00(a1)		;Stop TOD
	or.b	#$40,$e00(a1)		;Set Serial to output
	tst.b	$d00(a1)
	move.w	d2,$9c(a2)
	move.b	#$01,$400(a1)
	move.b	d4,$500(a1)
	move.b	#$59,$e00(a1)
	moveq	#$01,d3			;TA
	bsr.s	ReadCIA2
	move.b	#$01,$600(a1)
	move.b	d4,$700(a1)
	move.b	#$19,$f00(a1)
	moveq	#$02,d3			;TB
	bsr.s	ReadCIA2
	move.b	d4,$a00(a1)
	move.b	d4,$900(a1)
	move.b	#$01,$800(a1)
	move.b	#$80,$f00(a1)
	move.b	d4,$a00(a1)
	move.b	d4,$900(a1)
	move.b	d4,$800(a1)
	move.b	d4,$f00(a1)
	move.b	d4,$a00(a1)
	move.b	d4,$900(a1)
	move.b	d4,$800(a1)
	moveq	#$04,d3			;ALRM
	bsr.s	ReadCIA2
	move.b	#$51,$e00(a1)
	move.b	$c00(a1),$c00(a1)
	moveq	#$08,d3			;SP
	bsr.s	ReadCIA2
	move.b	d1,$d(a0)		;ICR
	move.b	d4,$e00(a1)
	rts
ReadCIA2
	move.b	$d00(a1),d0
	and.b	d3,d0
	beq.s	ReadCIA2
	and.w	d2,$1e(a2)
	beq.s	ReadCIA3
	or.b	d3,d1
ReadCIA3
	move.b	d3,$d00(a1)
	move.w	d2,$9c(a2)
	rts

WriteCIA				;Writes back the CIA registers
	movem.l	d0/a0-a1,-(a7)
	lea	$bfd000,a1
	bsr.s	WriteCIA1
	lea	$18(a0),a0
	lea	$bfe001,a1
	bsr.s	WriteCIA1
	movem.l	(a7)+,d0/a0-a1
	rts
WriteCIA1
	moveq	#$00,d0
	move.b	d0,$e00(a1)
	move.b	d0,$f00(a1)
	move.b	#$0f,$d00(a1)
	tst.b	$d00(a1)
	move.b	$2(a0),$200(a1)
	move.b	$0(a0),$000(a1)
	move.b	$3(a0),$300(a1)
	move.b	$1(a0),$100(a1)
	move.b	$4(a0),$400(a1)
	move.b	$5(a0),$500(a1)
	move.b	$6(a0),$600(a1)
	move.b	$7(a0),$700(a1)
	move.b	$a(a0),$a00(a1)
	move.b	$9(a0),$900(a1)
	move.b	$8(a0),$800(a1)
	move.b	$e(a0),d0
	or.b	#$10,d0
	move.b	d0,$e00(a1)
	move.b	$f(a0),d0
	or.b	#$10,d0
	move.b	d0,$f00(a1)
	move.b	$10(a0),$400(a1)
	move.b	$11(a0),$500(a1)
	move.b	$12(a0),$600(a1)
	move.b	$13(a0),$700(a1)
	move.b	$d(a0),d0
	or.b	#$80,d0
	move.b	d0,$d00(a1)
	rts

*************************************************************************
*	STRING DEFINITIONS						*
*************************************************************************

HeyText
	dc.b	$0a,"DEFJAM-CCS Proudly Presents:"
	dc.b	$0a,"       Desert Strike        "
	dc.b	$0a,"     Harddisk-Version       "
	dc.b	$0a
	dc.b	$0a,"       Made by PHS          "
	dc.b	$0a
	dc.b	$0a,"Originally cracked by PARADOX"
	dc.b	$0a
	dc.b	$0a,"Press Fire On Joystick...",$0a
HeyTextEnd
ShitText
	dc.b	$0a,"Sorry,out of memory...",$0a
ShitTextEnd
WindowName
	dc.b	"CON:20/20/600/160/Desert_Strike",0
DosName
	DOSNAME


	Section	SomeBuffer,BSS_F
_DOSBase
	ds.l	1
ChipCopyMem
	ds.l	1
ChipCopyEnd
	ds.l	1
GameExtraMem
	ds.l	1
SaveIRQEna1
	ds.l	1
SaveIRQEna2
	ds.l	1
SaveCIARegs1
	ds.l	$30/4
SaveCIARegs2
	ds.l	$30/4
SaveStack
	ds.l	1
UserStack
	ds.l	1
SuperStack
	ds.l	1
FileName
	ds.l	1
Bitplanes
	ds.l	6
ReturnValue
	ds.l	1
